/*
 * Common C Library
 *  types.h - some useful types
 *
 * (c) firk 2015, 2020, 2021; firk@cantconnect.ru
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */
#ifndef INCLUDED_FCL_TYPES_H
#define INCLUDED_FCL_TYPES_H

#define FCL_CHAR_BITS 8
#define FCL_SHORT_BITS 16
#define FCL_INT_BITS 32
#define FCL_LONG_BITS 32
#define FCL_LONGLONG_BITS 64
#define HAVE_LONGLONG
#define HAVE_INT8
#define HAVE_INT16
#define HAVE_INT32
#define HAVE_INT64
#define INT_GE32
/* int8=schar always; uint8=uchar always; other may vary */
typedef signed char int8, schar;
typedef signed short int16;
typedef signed int int32;
typedef signed long long int64;
typedef unsigned char uint8, uchar;
typedef unsigned short uint16;
typedef unsigned int uint32;
typedef unsigned long long uint64;
typedef unsigned short ushort;
typedef unsigned int uint;
typedef unsigned long ulong;
typedef signed long long llong;
typedef unsigned long long ullong;
#define FCL_LE 1
typedef unsigned int fcl_size;
typedef signed int fcl_ssize;
typedef unsigned int fcl_va_size;
typedef signed int fcl_va_ssize;
#define FCL_SIZE_BITS 32
#ifdef FCL_SIZE_T
typedef fcl_size size_t;
typedef fcl_ssize ssize_t;
#endif

#define FCL_INLINE static __inline__ __attribute__((always_inline))

#define FCL_NORETURN __attribute__((__noreturn__))

#endif

