/*
 * This file is part of firk's Common C Library
 *  conio/vt100key.h - vt100+ keyboard seqs parser
 *
 * (c) firk 2021; firk@cantconnect.ru
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */
#ifndef FCL_INCLUDED_VT100KEY_H
#define FCL_INCLUDED_VT100KEY_H

typedef struct {
  uint16  a[10];
  uint8   state, na, la;
} vt100key_parser_ctx;

/* return:
  -1  - no key sequence completed
  >=0 - key code for the just finished sequence (see keycodes.h) */

extern int32 vt100key_parse_byte(vt100key_parser_ctx * this, uchar c);

#endif

